array set markup_table_data {
    CommandTableName                                  ExampleCommands
}

set markup_struct_list {
    OneState
    TwoState
    ThreeState
}

array set markup_struct_data {
    OneState:field:integer:default                    313233
    OneState:field:integer:type                       int
    OneState:field:number:default                     312e32
    OneState:field:number:type                        double
    OneState:fieldsList                               {integer number}
    ThreeState:field:integer:default                  313233
    ThreeState:field:integer:type                     int
    ThreeState:field:mode:default                     30
    ThreeState:field:mode:type                        int
    ThreeState:field:number:default                   312e32
    ThreeState:field:number:type                      double
    ThreeState:fieldsList                             {integer number mode}
    TwoState:field:background:default                 44454641554c545f4241434b47524f554e445f4d4143524f
    TwoState:field:background:type                    double
    TwoState:field:foreground:default                 44454641554c545f464f524547524f554e445f4d4143524f
    TwoState:field:foreground:type                    int
    TwoState:fieldsList                               {foreground background}
}

set markup_rootcommand_list {
    one
    one
    two
    three
}

set markup_maincommand_list {
    one
    {one red}
}

set markup_command_list {
    {one green}
    {one white}
    {one red dark}
    {one red bright}
    one
    two
    three
}

array set markup_maincommand_data {
    {one red:commandsList}                            {{one red dark} {one red bright}}
    {one red:name}                                    red
    {one red:safe}                                    yes
    one:commandsList                                  {{one green} {one white} {one red}}
    one:name                                          one
    one:safe                                          yes
}

array set markup_command_data {
    {one green:callbackFunction}                      OneGreenFunction
    {one green:name}                                  green
    {one green:safe}                                  yes
    {one green:structName}                            {}
    {one green:synopsis}                              NULL
    {one red bright:callbackFunction}                 OneRedBrightFunction
    {one red bright:name}                             bright
    {one red bright:safe}                             yes
    {one red bright:structName}                       {}
    {one red bright:synopsis}                         NULL
    {one red dark:callbackFunction}                   OneRedDarkFunction
    {one red dark:name}                               dark
    {one red dark:safe}                               yes
    {one red dark:structName}                         {}
    {one red dark:synopsis}                           NULL
    {one white:callbackFunction}                      OneWhiteFunction
    {one white:name}                                  white
    {one white:safe}                                  yes
    {one white:structName}                            {}
    {one white:synopsis}                              NULL
    one:argumentsPairs                                {GetIntFromArg integer GetDoubleFromArg number}
    one:callbackFunction                              FirstFunction
    one:name                                          one
    one:safe                                          yes
    one:structName                                    OneState
    one:synopsis                                      "integer number"
    three:argumentsPairs                              {GetIntFromArg integer GetDoubleFromArg number}
    three:callbackFunction                            ThreeFunction
    three:name                                        three
    three:option:-off:extractor                       GetModeFromArg
    three:option:-off:hasarg                          0
    three:option:-off:member                          mode
    three:option:-on:extractor                        GetModeFromArg
    three:option:-on:hasarg                           0
    three:option:-on:member                           mode
    three:optionsList                                 {-on -off}
    three:safe                                        yes
    three:structName                                  ThreeState
    three:synopsis                                    "integer number ?options?"
    two:callbackFunction                              TwoFunction
    two:name                                          two
    two:option:-background:extractor                  GetColorFromArg
    two:option:-background:hasarg                     1
    two:option:-background:member                     background
    two:option:-foreground:extractor                  GetColorFromArg
    two:option:-foreground:hasarg                     1
    two:option:-foreground:member                     foreground
    two:optionsList                                   {-foreground -background}
    two:safe                                          yes
    two:structName                                    TwoState
    two:synopsis                                      "?options?"
}

set markup_extractor_list {
    GetIntFromArg
    GetDoubleFromArg
    GetColorFromArg
    GetModeFromArg
}

array set markup_extractor_data {
    GetDoubleFromArg:declaration                      omit
    GetIntFromArg:declaration                         EXTERN
    GetModeFromArg:declaration                        static
}


